import logging
from . import Field as Field, GetResult as GetResult, PropertyValue as PropertyValue, noapi as noapi
from .Link import Link as Link
from .List import List as List
from .Property import Property as Property
from .Slice import Slice as Slice
from .datatypes import datatypes as datatypes
from .msg import msg as msg
from collections.abc import Iterator as Iterator
from typing import Any, Dict, Optional, Union
from typing_extensions import TypeAlias

upython: bool
console = logging
PythonClass: TypeAlias

class Item:
    def __init__(self, *args: Any) -> None: ...
    def get(self, key: str) -> Field: ...
    def __getitem__(self, key: str) -> Any: ...
    def __getattr__(self, key: str) -> Any: ...
    def on_update(self, field_name: str, callback: Any) -> None: ...
    def __setitem__(self, key: str, newvalue: PropertyValue) -> None: ...
    def __setattr__(self, key: str, newvalue: PropertyValue) -> None: ...
    def set_nowait(self, field: str, new_value: Item | PropertyValue) -> None: ...
    def set(self, field: str, new_value: Item | PropertyValue) -> None: ...
    def create(self, DEPRECATED_FUNCTION: Any) -> Item: ...
    def create_subitem(self, key: str, set_value: Optional['PropertyValue'] = None, on_property: Optional[str] = None) -> Item: ...
    def destroy_subitem(self, containername: str, item: Item) -> None: ...
    def keys(self) -> None: ...
    def call_method(self, name: str, args: Dict[str, Optional[str]] = {}) -> Dict[str, Optional[str]]: ...
    def define_property(self, name: str, proptype: Union[str, PythonClass, None] = None) -> Item: ...
    def define_calculated_property(self, property_name: str, data_type: str, formula: str) -> Item: ...
    def define_calculated_list(self, list_name: str, range: str, formula: str, inverse_name: Optional[str] = None) -> Item: ...
    def define_calculated_link(self, link_name: str, range: str, formula: str, inverse_name: Optional[str] = None) -> Item: ...
    def recall_field(self, field_name: str) -> Optional['Item']: ...
    def new_subitem(self, DEPRECATED_FUNCTION: Any, DEPRECATEDFUNCTION: Any) -> None: ...
    def destroy(**DEPRECATED_FUNCTION: Any) -> None: ...
    def define_subitem(self, subitem_name: str, inverse_name: Optional[str] = None) -> Item: ...
    def define_link(self, link_name: str, range: Optional[str] = None, inverse_name: Optional[str] = None, inverse_link_or_list: Optional[str] = 'list', inverse_range: Optional[str] = None) -> Item: ...
    def define_list(self, list_name: str, range: Optional[str] = None, inverse_name: Optional[str] = None, inverse_link_or_list: Optional[str] = 'link', inverse_range: Optional[str] = None) -> Item: ...
    def define_list_of_links(self, list_name: str, range: Optional[str] = None, inverse_name: Optional[str] = None, inverse_cardinal: Optional[str] = 'link', inverse_range: Optional[str] = None) -> Item: ...
    def define_list_of_items(self, list_name: str, inverse_name: Optional[str] = None) -> Item: ...
    def __iter__(self) -> None: ...
